#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include "flash.h"

//access only 512-byte for each page

#define BytePerPage		512	

int main(void)
{
int i;
int ret;
char cChar;
unsigned int page;
unsigned int block;
unsigned int tmp;
unsigned char data[512];


init_flash();

ret=flash_id_read();
printf("ID =%x\n",ret);

for(;;)
{
printf("\n*********** Flash Card Diagnostic Program **************");

printf("\n*           Access after block mapping                 *");
printf("\n*       E : Erase                                      *");
printf("\n*       W : Write                                      *");
printf("\n*       R : Read                                       *");
printf("\n*       Q : quit                                       *");
printf("\n*************** Press Keyword **************************");
printf("\n");
cChar=getch();
switch (cChar)
	{
	case 'E': 
	case 'e': 
		printf("Erase page?\n");
		printf("Which will erase (page&0xFFE0) ~ (page&0xFFE0 +31)\n");
		scanf("%d",&page);

		flash_block_erase(page);

		break;
		
	case 'W':
	case 'w':
		printf("Write Page?\n");
		scanf("%d",&page);
		printf("0 for sequencial Pattern, others for fixed pattern\n");
		scanf("%d",&tmp);
		
		if (tmp == 0){
			for(i=0;i<512;i++){
				data[i]=i;
			}
			
						
		} else{
			for(i=0;i<512;i++){
				data[i]=tmp;
			}
		}


		ret=flash_page_write(page,data);

		printf("Write Return %d\n",ret);
		break;
		
	case 'R':
	case 'r':
		printf("Read Page?\n");
		scanf("%d",&page);		
	

		ret=flash_page_read(page,data);

		printf("Read Return %d\n",ret);
					

		for(i=0;i<512;i++){

			printf("0x%02x,",data[i]);
			if(((i+1)&0xff)==0)
				printf("\n");
		}

		break;
		

		
	case 'q':
	case 'Q': goto ret_label;
	default : printf(" --> Error Keyword"); break;
	}

}
ret_label:
	close_flash();
	return 0;
}

