/* char : 8-bit
   short, int : 16-bit
   long: 32-bit
*/
static void InitPcs(void)
{
	unsigned int PIOMODE1,PIODIR1,MPCS,PCSS,RELREG,PIOMODE0,PIODIR0;
	/* set PCS0,INT4 to normal, 9188e*/
/*	PIOMODE1=inport(0xff76);
	PIODIR1=inport(0xff78);
	PIOMODE1 &= 0x7ffe;
	PIODIR1  &= 0x7ffe;
	PIOMODE1 |= 0x4000;
	PIODIR1  |= 0x4000;
	outport(0xff76,PIOMODE1);
	outport(0xff78,PIODIR1);
*/	RELREG=inport(0xfffe);
	RELREG&=0xefff;
	outport(0xfffe,RELREG);
	/*set MPCS MS=0 EX=0 to let PCS become I/O bus */
	MPCS=inport(0xffa8);
	MPCS&=0xff3f;
	outport(0xffa8,MPCS);
	/*to set COM1_BASE=0, and wait state=15*/
	outport(0xffa4,0x007f);
	outportb(0,0x7f);
}

/* adr is between 0~2^19) */
unsigned char ReadByte(unsigned long adr)
{
	unsigned char data;
	inportb(0x80, ((adr&0x78000 )>>15)); 
	inportb(0x81, ((adr&0x07F80 )>>7)); 
	data=inportb(adr&0x7F );
	return data;
}

unsigned char WriteByte(unsigned long adr, unsigned char data)
{
	outportb (0x80, ((adr &0x78000 )>>15));
	outportb (0x81, ((adr &0x07F80 )>>7));
	outportb (adr &0x7F, data );
	return 0;
}

unsigned char ReadMass(unsigned long adr, unsigned long length)
{
	unsigned long ulTmp;
	unsigned int blkAdr;
	unsigned int blkAdre;
	blkAdr=(adr>>7)&0x7FF; //adr 2^19 --> (7-bit block) --> 2^12 --> 11 adr lines
	ulTmp=adr+length;
	inportb(0x80, ((adr&0x78000 )>>15)); 
	inportb(0x81, ((adr&0x07F80 )>>7)); 
	data=inportb(adr&0x7F );

	while (adr != (ulTmp>>7)){
	
	}
	
}

int main()
{
	unsigned long i;
	unsigned char wdata;
	unsigned char rdata;
	InitPcs();
	
	wdata=0x5a;
	for(i=0;i<0x80000;i++){
		WriteByte(i,wdata++);
	}

	wdata=0x5a;
	for(i=0;i<0x80000;i++){
		rdata=ReadByte(i);
		if(wdata != rdata){
			printf("Error0: add=%x, write=%x, read=%x\n",i, wdata, rdata);
		}
		wdata++;
	}

	wdata=0xa5;
	for(i=0;i<0x80000;i++){
		WriteByte(i,wdata++);
	}

	wdata=0xa5;
	for(i=0;i<0x80000;i++){
		rdata=ReadByte(i);
		if(wdata != rdata){
			printf("Error1: add=%x, write=%x, read=%x\n",i, wdata, rdata);
		}
		wdata++;
	}
	
}
